import org.apache.pulsar.client.api.*;

public class ReaderOrder {
	public static void main(String[] args) throws Exception {
		PulsarClient pulsarClient = PulsarClient.builder().serviceUrl("pulsar://localhost:6650").build();
		Reader<String> reader = pulsarClient.newReader(Schema.STRING)
			.topic("public/default/order-json-key-date")
			.startMessageId(MessageId.earliest)
			.readerName("reader-sub")
			.receiverQueueSize(10000)
			.create();

		Message<String> message = null;
		try {

			int numLines = 0;
			while (reader.hasMessageAvailable()) {
				message = reader.readNext();
				numLines++;
				//if (numLines % 1000000 == 0) {
					System.out.println("Num lines: " + numLines);
					System.out.println("Message id: " + message.getMessageId());
					System.out.println("Message key: " + message.getKey() );
					System.out.println("Message value: " + message.getValue() );
					System.out.println("Message publish time: " + message.getPublishTime() );
					System.out.println("Message event time: " + message.getEventTime() );
				//}
			}

			System.out.println("Done reading");
			reader.close();
			System.out.println("Closed reader");
			pulsarClient.close();
			System.out.println("Closed client");
		}
		catch (Exception e) {
			reader.close();
			System.out.println("Closed reader");
			pulsarClient.close();
			System.out.println("Closed client");
			e.printStackTrace();
		}
	}
}
